/[gentoo-x86]/eclass/qt4-build.eclass
Gentoo

Diff of /eclass/qt4-build.eclass

Parent Directory Parent Directory | Revision Log Revision Log | View Patch Patch

Revision 1.13 Revision 1.150
1# Copyright 2007-2008 Gentoo Foundation 1# Copyright 1999-2013 Gentoo Foundation
2# Distributed under the terms of the GNU General Public License v2 2# Distributed under the terms of the GNU General Public License v2
3# $Header: /var/cvsroot/gentoo-x86/eclass/qt4-build.eclass,v 1.13 2008/05/15 12:33:53 ingmar Exp $ 3# $Header: /var/cvsroot/gentoo-x86/eclass/qt4-build.eclass,v 1.150 2013/08/13 10:17:54 pesa Exp $
4 4
5# @ECLASS: qt4-build.eclass 5# @ECLASS: qt4-build.eclass
6# @MAINTAINER: 6# @MAINTAINER:
7# Caleb Tennis <caleb@gentoo.org> 7# Qt herd <qt@gentoo.org>
8# @BLURB: Eclass for Qt4 split ebuilds. 8# @BLURB: Eclass for Qt4 split ebuilds.
9# @DESCRIPTION: 9# @DESCRIPTION:
10# This eclass contains various functions that are used when building Qt4 10# This eclass contains various functions that are used when building Qt4.
11 11
12inherit eutils multilib toolchain-funcs flag-o-matic
13
14IUSE="${IUSE} debug pch"
15
16case "${PV}" in 12case ${EAPI} in
17 4.4.0_beta*) 13 4|5) : ;;
18 SRCTYPE="${SRCTYPE:-opensource-src}" 14 *) die "qt4-build.eclass: unsupported EAPI=${EAPI:-0}" ;;
19 MY_PV="${PV/_beta/-beta}" 15esac
16
17inherit eutils flag-o-matic multilib toolchain-funcs versionator
18
19if [[ ${PV} == *9999* ]]; then
20 QT4_BUILD_TYPE="live"
21 inherit git-2
22else
23 QT4_BUILD_TYPE="release"
24fi
25
26HOMEPAGE="http://qt-project.org/ http://qt.digia.com/"
27LICENSE="|| ( LGPL-2.1 GPL-3 )"
28
29MY_PV=${PV/_/-}
30MY_P=qt-everywhere-opensource-src-${MY_PV}
31
32case ${QT4_BUILD_TYPE} in
33 live)
34 EGIT_REPO_URI="git://gitorious.org/qt/qt.git
35 https://git.gitorious.org/qt/qt.git"
36 EGIT_BRANCH=${PV%.9999}
20 ;; 37 ;;
21 4.4.0_rc*) 38 release)
22 SRCTYPE="${SRCTYPE:-opensource-src}" 39 SRC_URI="http://download.qt-project.org/official_releases/qt/${PV%.*}/${PV}/${MY_P}.tar.gz"
23 MY_PV="${PV/_rc/-rc}"
24 ;;
25 *)
26 SRCTYPE="${SRCTYPE:-opensource-src}"
27 MY_PV="${PV}"
28 ;; 40 ;;
29esac 41esac
30MY_P=qt-x11-${SRCTYPE}-${MY_PV} 42
43IUSE="aqua debug pch"
44[[ ${CATEGORY}/${PN} != dev-qt/qtwebkit ]] && IUSE+=" c++0x"
45[[ ${CATEGORY}/${PN} != dev-qt/qtxmlpatterns ]] && IUSE+=" +exceptions"
46
47DEPEND="virtual/pkgconfig"
48if [[ ${QT4_BUILD_TYPE} == live ]]; then
49 DEPEND+=" dev-lang/perl"
50fi
51
31S=${WORKDIR}/${MY_P} 52S=${WORKDIR}/${MY_P}
32 53
33SRC_URI="ftp://ftp.trolltech.com/qt/source/${MY_P}.tar.bz2" 54# @FUNCTION: qt4-build_pkg_setup
34 55# @DESCRIPTION:
35case "${PV}" in 56# Sets up PATH and LD_LIBRARY_PATH.
36 4.4.0|4.4.0_rc*)
37 SRC_URI="${SRC_URI} mirror://gentoo/${MY_P}-headers.tar.bz2"
38 ;;
39 *)
40 ;;
41esac
42
43qt4-build_pkg_setup() { 57qt4-build_pkg_setup() {
44 # Check USE requirements 58 # Protect users by not allowing downgrades between releases.
45 qt4-build_check_use 59 # Downgrading revisions within the same release should be allowed.
60 if has_version ">${CATEGORY}/${P}-r9999:4"; then
61 if [[ -z ${I_KNOW_WHAT_I_AM_DOING} ]]; then
62 eerror " *** Sanity check to keep you from breaking your system ***"
63 eerror "Downgrading Qt is completely unsupported and will break your system!"
64 die "aborting to save your system"
65 else
66 ewarn "Downgrading Qt is completely unsupported and will break your system!"
67 fi
68 fi
46 69
70 PATH="${S}/bin${PATH:+:}${PATH}"
71 if [[ ${CHOST} != *-darwin* ]]; then
72 LD_LIBRARY_PATH="${S}/lib${LD_LIBRARY_PATH:+:}${LD_LIBRARY_PATH}"
73 else
74 DYLD_LIBRARY_PATH="${S}/lib${DYLD_LIBRARY_PATH:+:}${DYLD_LIBRARY_PATH}"
75 # On MacOS we *need* at least src/gui/kernel/qapplication_mac.mm for
76 # platform detection. Note: needs to come before any directories to
77 # avoid extract failure.
78 [[ ${CHOST} == *-apple-darwin* ]] && \
79 QT4_EXTRACT_DIRECTORIES="src/gui/kernel/qapplication_mac.mm
80 ${QT4_EXTRACT_DIRECTORIES}"
81 fi
82}
83
84# @ECLASS-VARIABLE: QT4_EXTRACT_DIRECTORIES
85# @DEFAULT_UNSET
86# @DESCRIPTION:
87# Space-separated list including the directories that will be extracted from
88# Qt tarball.
89
90# @ECLASS-VARIABLE: QT4_TARGET_DIRECTORIES
91# @DEFAULT_UNSET
92# @DESCRIPTION:
93# Arguments for build_target_directories. Takes the directories in which the
94# code should be compiled. This is a space-separated list.
95
96# @FUNCTION: qt4-build_src_unpack
97# @DESCRIPTION:
98# Unpacks the sources.
99qt4-build_src_unpack() {
100 setqtenv
101
102 if ! version_is_at_least 4.1 $(gcc-version); then
103 ewarn "Using a GCC version lower than 4.1 is not supported."
104 elif use_if_iuse c++0x && ! version_is_at_least 4.4 $(gcc-version); then
105 ewarn "USE=c++0x requires GCC 4.4 or later."
106 fi
107
108 if [[ ${CATEGORY}/${PN} == dev-qt/qtwebkit ]]; then
109 eshopts_push -s extglob
110 if is-flagq '-g?(gdb)?([1-9])'; then
111 echo
112 ewarn "You have enabled debug info (probably have -g or -ggdb in your CFLAGS/CXXFLAGS)."
113 ewarn "You may experience really long compilation times and/or increased memory usage."
114 ewarn "If compilation fails, please try removing -g/-ggdb before reporting a bug."
115 ewarn "For more info check out https://bugs.gentoo.org/307861"
116 echo
117 fi
118 eshopts_pop
119 fi
120
121 case ${QT4_BUILD_TYPE} in
122 live)
123 git-2_src_unpack
124 ;;
125 release)
126 local tarball="${MY_P}.tar.gz" target= targets=
127 for target in configure LICENSE.GPL3 LICENSE.LGPL projects.pro \
128 src/{qbase,qt_targets,qt_install}.pri bin config.tests \
129 mkspecs qmake ${QT4_EXTRACT_DIRECTORIES}
130 do
131 targets+="${MY_P}/${target} "
132 done
133
134 ebegin "Unpacking parts of ${tarball}:" ${targets//${MY_P}\/}
135 tar -xzf "${DISTDIR}/${tarball}" ${targets}
136 eend $? || die "failed to unpack"
137 ;;
138 esac
139}
140
141# @ECLASS-VARIABLE: PATCHES
142# @DEFAULT_UNSET
143# @DESCRIPTION:
144# PATCHES array variable containing all various patches to be applied.
145# This variable is expected to be defined in global scope of ebuild.
146# Make sure to specify the full path. This variable is utilised in
147# src_prepare() phase.
148#
149# @CODE
150# PATCHES=( "${FILESDIR}/mypatch.patch"
151# "${FILESDIR}/patches_folder/" )
152# @CODE
153
154# @FUNCTION: qt4-build_src_prepare
155# @DESCRIPTION:
156# Prepare the sources before the configure phase. Strip CFLAGS if necessary, and fix
157# the build system in order to respect CFLAGS/CXXFLAGS/LDFLAGS specified in make.conf.
158qt4-build_src_prepare() {
159 setqtenv
160
161 if [[ ${QT4_BUILD_TYPE} == live ]]; then
162 QTDIR="." ./bin/syncqt || die "syncqt failed"
163 fi
164
165 # avoid X11 dependency in non-gui packages
166 local nolibx11_pkgs="qtcore qtdbus qtscript qtsql qttest qtxmlpatterns"
167 has ${PN} ${nolibx11_pkgs} && qt_nolibx11
168
169 if use aqua; then
170 # provide a proper macx-g++-64
171 use x64-macos && ln -s macx-g++ mkspecs/$(qt_mkspecs_dir)
172
173 sed -e '/^CONFIG/s:app_bundle::' \
174 -e '/^CONFIG/s:plugin_no_soname:plugin_with_soname absolute_library_soname:' \
175 -i mkspecs/$(qt_mkspecs_dir)/qmake.conf || die
176 fi
177
178 if [[ ${CATEGORY}/${PN} != dev-qt/qtcore ]]; then
179 skip_qmake_build
180 skip_project_generation
181 symlink_binaries_to_buildtree
182 fi
183
184 if use_if_iuse c++0x; then
185 append-cxxflags -std=c++0x
186 fi
187
188 # Bug 261632
189 if use ppc64; then
190 append-flags -mminimal-toc
191 fi
192
193 # Bug 373061
194 # qmake bus errors with -O2 or -O3 but -O1 works
195 if [[ ${CHOST} == *86*-apple-darwin* ]]; then
196 replace-flags -O[23] -O1
197 fi
198
199 # Bug 417105
200 # graphite on gcc 4.7 causes miscompilations
201 if [[ $(gcc-version) == "4.7" ]]; then
202 filter-flags -fgraphite-identity
203 fi
204
205 # Respect CC, CXX, {C,CXX,LD}FLAGS in .qmake.cache
206 sed -e "/^SYSTEM_VARIABLES=/i \
207 CC='$(tc-getCC)'\n\
208 CXX='$(tc-getCXX)'\n\
209 CFLAGS='${CFLAGS}'\n\
210 CXXFLAGS='${CXXFLAGS}'\n\
211 LDFLAGS='${LDFLAGS}'\n\
212 QMakeVar set QMAKE_CFLAGS_RELEASE\n\
213 QMakeVar set QMAKE_CFLAGS_DEBUG\n\
214 QMakeVar set QMAKE_CXXFLAGS_RELEASE\n\
215 QMakeVar set QMAKE_CXXFLAGS_DEBUG\n\
216 QMakeVar set QMAKE_LFLAGS_RELEASE\n\
217 QMakeVar set QMAKE_LFLAGS_DEBUG\n"\
218 -i configure \
219 || die "sed SYSTEM_VARIABLES failed"
220
221 # Respect CC, CXX, LINK and *FLAGS in config.tests
222 find config.tests/unix -name '*.test' -type f -print0 | xargs -0 \
223 sed -i -e "/bin\/qmake/ s: \"\$SRCDIR/: \
224 'QMAKE_CC=$(tc-getCC)' 'QMAKE_CXX=$(tc-getCXX)' 'QMAKE_LINK=$(tc-getCXX)' \
225 'QMAKE_CFLAGS+=${CFLAGS}' 'QMAKE_CXXFLAGS+=${CXXFLAGS}' 'QMAKE_LFLAGS+=${LDFLAGS}'&:" \
226 || die "sed config.tests failed"
227
228 # Bug 172219
229 sed -e 's:/X11R6/:/:' -i mkspecs/$(qt_mkspecs_dir)/qmake.conf || die
230
231 if [[ ${CHOST} == *-darwin* ]]; then
232 # Set FLAGS *and* remove -arch, since our gcc-apple is multilib
233 # crippled (by design) :/
234 local mac_gpp_conf=
235 if [[ -f mkspecs/common/mac-g++.conf ]]; then
236 # qt < 4.8 has mac-g++.conf
237 mac_gpp_conf="mkspecs/common/mac-g++.conf"
238 elif [[ -f mkspecs/common/g++-macx.conf ]]; then
239 # qt >= 4.8 has g++-macx.conf
240 mac_gpp_conf="mkspecs/common/g++-macx.conf"
241 else
242 die "no known conf file for mac found"
243 fi
244 sed \
245 -e "s:QMAKE_CFLAGS_RELEASE.*=.*:QMAKE_CFLAGS_RELEASE=${CFLAGS}:" \
246 -e "s:QMAKE_CXXFLAGS_RELEASE.*=.*:QMAKE_CXXFLAGS_RELEASE=${CXXFLAGS}:" \
247 -e "s:QMAKE_LFLAGS_RELEASE.*=.*:QMAKE_LFLAGS_RELEASE=-headerpad_max_install_names ${LDFLAGS}:" \
248 -e "s:-arch\s\w*::g" \
249 -i ${mac_gpp_conf} \
250 || die "sed ${mac_gpp_conf} failed"
251
252 # Fix configure's -arch settings that appear in qmake/Makefile and also
253 # fix arch handling (automagically duplicates our -arch arg and breaks
254 # pch). Additionally disable Xarch support.
255 local mac_gcc_confs="${mac_gpp_conf}"
256 if [[ -f mkspecs/common/gcc-base-macx.conf ]]; then
257 mac_gcc_confs+=" mkspecs/common/gcc-base-macx.conf"
258 fi
259 sed \
260 -e "s:-arch i386::" \
261 -e "s:-arch ppc::" \
262 -e "s:-arch x86_64::" \
263 -e "s:-arch ppc64::" \
264 -e "s:-arch \$i::" \
265 -e "/if \[ ! -z \"\$NATIVE_64_ARCH\" \]; then/,/fi/ d" \
266 -e "s:CFG_MAC_XARCH=yes:CFG_MAC_XARCH=no:g" \
267 -e "s:-Xarch_x86_64::g" \
268 -e "s:-Xarch_ppc64::g" \
269 -i configure ${mac_gcc_confs} \
270 || die "sed -arch/-Xarch failed"
271
272 # On Snow Leopard don't fall back to 10.5 deployment target.
273 if [[ ${CHOST} == *-apple-darwin10 ]]; then
274 sed -e "s:QMakeVar set QMAKE_MACOSX_DEPLOYMENT_TARGET.*:QMakeVar set QMAKE_MACOSX_DEPLOYMENT_TARGET 10.6:g" \
275 -e "s:-mmacosx-version-min=10.[0-9]:-mmacosx-version-min=10.6:g" \
276 -i configure ${mac_gpp_conf} \
277 || die "sed deployment target failed"
278 fi
279 fi
280
281 # this one is needed for all systems with a separate -liconv, apart from
282 # Darwin, for which the sources already cater for -liconv
283 if use !elibc_glibc && [[ ${CHOST} != *-darwin* ]]; then
284 sed -e 's|mac:\(LIBS += -liconv\)|\1|g' \
285 -i config.tests/unix/iconv/iconv.pro \
286 || die "sed iconv.pro failed"
287 fi
288
289 # we need some patches for Solaris
290 sed -i -e '/^QMAKE_LFLAGS_THREAD/a\QMAKE_LFLAGS_DYNAMIC_LIST = -Wl,--dynamic-list,' \
291 mkspecs/$(qt_mkspecs_dir)/qmake.conf || die
292 # use GCC over SunStudio
293 sed -i -e '/PLATFORM=solaris-cc/s/cc/g++/' configure || die
294 # do not flirt with non-Prefix stuff, we're quite possessive
295 sed -i -e '/^QMAKE_\(LIB\|INC\)DIR\(_X11\|_OPENGL\|\)\t/s/=.*$/=/' \
296 mkspecs/$(qt_mkspecs_dir)/qmake.conf || die
297
298 # apply patches
299 [[ -n ${PATCHES[@]} ]] && epatch "${PATCHES[@]}"
300 epatch_user
301}
302
303# @FUNCTION: qt4-build_src_configure
304# @DESCRIPTION:
305# Default configure phase
306qt4-build_src_configure() {
307 setqtenv
308
309 local conf="
310 -prefix ${QTPREFIXDIR}
311 -bindir ${QTBINDIR}
312 -libdir ${QTLIBDIR}
313 -docdir ${QTDOCDIR}
314 -headerdir ${QTHEADERDIR}
315 -plugindir ${QTPLUGINDIR}
316 -importdir ${QTIMPORTDIR}
317 -datadir ${QTDATADIR}
318 -translationdir ${QTTRANSDIR}
319 -sysconfdir ${QTSYSCONFDIR}
320 -examplesdir ${QTEXAMPLESDIR}
321 -demosdir ${QTDEMOSDIR}
322 -opensource -confirm-license
323 -shared -fast -largefile -stl -verbose
324 -nomake examples -nomake demos"
325
326 # ARCH is set on Gentoo. Qt now falls back to generic on an unsupported
327 # $(tc-arch). Therefore we convert it to supported values.
328 case "$(tc-arch)" in
329 amd64|x64-*) conf+=" -arch x86_64" ;;
330 ppc-macos) conf+=" -arch ppc" ;;
331 ppc|ppc64|ppc-*) conf+=" -arch powerpc" ;;
332 sparc|sparc-*|sparc64-*) conf+=" -arch sparc" ;;
333 x86-macos) conf+=" -arch x86" ;;
334 x86|x86-*) conf+=" -arch i386" ;;
335 alpha|arm|ia64|mips|s390) conf+=" -arch $(tc-arch)" ;;
336 hppa|sh) conf+=" -arch generic" ;;
337 *) die "$(tc-arch) is unsupported by this eclass. Please file a bug." ;;
338 esac
339
340 conf+=" -platform $(qt_mkspecs_dir)"
341
342 [[ $(get_libdir) != lib ]] && conf+=" -L${EPREFIX}/usr/$(get_libdir)"
343
344 # debug/release
345 if use debug; then
346 conf+=" -debug"
347 else
348 conf+=" -release"
349 fi
350 conf+=" -no-separate-debug-info"
351
352 # exceptions USE flag
353 conf+=" $(in_iuse exceptions && qt_use exceptions || echo -exceptions)"
354
355 # disable rpath (bug 380415), except on prefix (bug 417169)
356 use prefix || conf+=" -no-rpath"
357
358 # precompiled headers don't work on hardened, where the flag is masked
359 conf+=" $(qt_use pch)"
360
361 # -reduce-relocations
362 # This flag seems to introduce major breakage to applications,
363 # mostly to be seen as a core dump with the message "QPixmap: Must
364 # construct a QApplication before a QPaintDevice" on Solaris.
365 # -- Daniel Vergien
366 [[ ${CHOST} != *-solaris* ]] && conf+=" -reduce-relocations"
367
368 # this one is needed for all systems with a separate -liconv, apart from
369 # Darwin, for which the sources already cater for -liconv
370 if use !elibc_glibc && [[ ${CHOST} != *-darwin* ]]; then
371 conf+=" -liconv"
372 fi
373
374 if use_if_iuse glib; then
375 local glibflags="$(pkg-config --cflags --libs glib-2.0 gthread-2.0)"
376 # avoid the -pthread argument
377 conf+=" ${glibflags//-pthread}"
378 unset glibflags
379 fi
380
381 if use aqua; then
382 # On (snow) leopard use the new (frameworked) cocoa code.
383 if [[ ${CHOST##*-darwin} -ge 9 ]]; then
384 conf+=" -cocoa -framework"
385 # We need the source's headers, not the installed ones.
386 conf+=" -I${S}/include"
387 # Add hint for the framework location.
388 conf+=" -F${QTLIBDIR}"
389
390 # We are crazy and build cocoa + qt3support :-)
391 if use qt3support; then
392 sed -e "/case \"\$PLATFORM,\$CFG_MAC_COCOA\" in/,/;;/ s|CFG_QT3SUPPORT=\"no\"|CFG_QT3SUPPORT=\"yes\"|" \
393 -i configure || die
394 fi
395 else
396 conf+=" -no-framework"
397 fi
398 else
399 # freetype2 include dir is non-standard, thus pass it to configure
400 conf+=" $(pkg-config --cflags-only-I freetype2)"
401 fi
402
403 conf+=" ${myconf}"
404 myconf=
405
406 echo ./configure ${conf}
407 ./configure ${conf} || die "./configure failed"
408
409 prepare_directories ${QT4_TARGET_DIRECTORIES}
410}
411
412# @FUNCTION: qt4-build_src_compile
413# @DESCRIPTION:
414# Actual compile phase
415qt4-build_src_compile() {
416 setqtenv
417
418 build_directories ${QT4_TARGET_DIRECTORIES}
419}
420
421# @FUNCTION: qt4-build_src_test
422# @DESCRIPTION:
423# Runs tests only in target directories.
424qt4-build_src_test() {
425 # QtMultimedia does not have any test suite (bug #332299)
426 [[ ${CATEGORY}/${PN} == dev-qt/qtmultimedia ]] && return
427
428 for dir in ${QT4_TARGET_DIRECTORIES}; do
429 emake -j1 check -C ${dir}
430 done
431}
432
433# @FUNCTION: fix_includes
434# @DESCRIPTION:
435# For MacOS X we need to add some symlinks when frameworks are
436# being used, to avoid complications with some more or less stupid packages.
437fix_includes() {
438 if use aqua && [[ ${CHOST##*-darwin} -ge 9 ]]; then
439 local frw dest f h rdir
440 # Some packages tend to include <Qt/...>
441 dodir "${QTHEADERDIR#${EPREFIX}}"/Qt
442
443 # Fake normal headers when frameworks are installed... eases life later
444 # on, make sure we use relative links though, as some ebuilds assume
445 # these dirs exist in src_install to add additional files
446 f=${QTHEADERDIR}
447 h=${QTLIBDIR}
448 while [[ -n ${f} && ${f%%/*} == ${h%%/*} ]] ; do
449 f=${f#*/}
450 h=${h#*/}
451 done
452 rdir=${h}
453 f="../"
454 while [[ ${h} == */* ]] ; do
455 f="${f}../"
456 h=${h#*/}
457 done
458 rdir="${f}${rdir}"
459
460 for frw in "${D}${QTLIBDIR}"/*.framework; do
461 [[ -e "${frw}"/Headers ]] || continue
462 f=$(basename ${frw})
463 dest="${QTHEADERDIR#${EPREFIX}}"/${f%.framework}
464 dosym "${rdir}"/${f}/Headers "${dest}"
465
466 # Link normal headers as well.
467 for hdr in "${D}/${QTLIBDIR}/${f}"/Headers/*; do
468 h=$(basename ${hdr})
469 dosym "../${rdir}"/${f}/Headers/${h} \
470 "${QTHEADERDIR#${EPREFIX}}"/Qt/${h}
471 done
472 done
473 fi
474}
475
476# @FUNCTION: qt4-build_src_install
477# @DESCRIPTION:
478# Perform the actual installation including some library fixes.
479qt4-build_src_install() {
480 setqtenv
481
482 install_directories ${QT4_TARGET_DIRECTORIES}
483 install_qconfigs
484 fix_library_files
485 fix_includes
486
487 # remove .la files since we are building only shared libraries
488 prune_libtool_files
489}
490
491# @FUNCTION: setqtenv
492# @INTERNAL
493setqtenv() {
47 # Set up installation directories 494 # Set up installation directories
48 QTBASEDIR=/usr/$(get_libdir)/qt4
49 QTPREFIXDIR=/usr 495 QTPREFIXDIR=${EPREFIX}/usr
50 QTBINDIR=/usr/bin 496 QTBINDIR=${QTPREFIXDIR}/bin
51 QTLIBDIR=/usr/$(get_libdir)/qt4 497 QTLIBDIR=${QTPREFIXDIR}/$(get_libdir)/qt4
52 QTPCDIR=/usr/$(get_libdir)/pkgconfig 498 QTPCDIR=${QTPREFIXDIR}/$(get_libdir)/pkgconfig
53 QTDATADIR=/usr/share/qt4
54 QTDOCDIR=/usr/share/doc/qt-${PV} 499 QTDOCDIR=${QTPREFIXDIR}/share/doc/qt-${PV}
55 QTHEADERDIR=/usr/include/qt4 500 QTHEADERDIR=${QTPREFIXDIR}/include/qt4
56 QTPLUGINDIR=${QTLIBDIR}/plugins 501 QTPLUGINDIR=${QTLIBDIR}/plugins
57 QTSYSCONFDIR=/etc/qt4 502 QTIMPORTDIR=${QTLIBDIR}/imports
503 QTDATADIR=${QTPREFIXDIR}/share/qt4
58 QTTRANSDIR=${QTDATADIR}/translations 504 QTTRANSDIR=${QTDATADIR}/translations
505 QTSYSCONFDIR=${EPREFIX}/etc/qt4
59 QTEXAMPLESDIR=${QTDATADIR}/examples 506 QTEXAMPLESDIR=${QTDATADIR}/examples
60 QTDEMOSDIR=${QTDATADIR}/demos 507 QTDEMOSDIR=${QTDATADIR}/demos
508 QMAKE_LIBDIR_QT=${QTLIBDIR}
61 509
62 PLATFORM=$(qt_mkspecs_dir) 510 PLATFORM=$(qt_mkspecs_dir)
511 unset QMAKESPEC
63 512
64 PATH="${S}/bin:${PATH}" 513 export XDG_CONFIG_HOME="${T}"
65 LD_LIBRARY_PATH="${S}/lib:${LD_LIBRARY_PATH}"
66} 514}
67 515
68qt4_unpack() { 516# @FUNCTION: prepare_directories
69 local target targets 517# @USAGE: < directories >
70 for target in configure LICENSE.{GPL2,GPL3,QPL} projects.pro \ 518# @INTERNAL
71 src/{qbase,qt_targets,qt_install}.pri bin config.tests mkspecs qmake \ 519# @DESCRIPTION:
72 ${QT4_EXTRACT_DIRECTORIES}; do 520# Generates Makefiles for the given list of directories.
73 targets="${targets} ${MY_P}/${target}" 521prepare_directories() {
522 for x in "$@"; do
523 pushd "${S}"/${x} >/dev/null || die
524 einfo "Running qmake in: ${x}"
525 "${S}"/bin/qmake \
526 "LIBS+=-L${QTLIBDIR}" \
527 "CONFIG+=nostrip" \
528 || die "qmake failed"
529 popd >/dev/null || die
74 done 530 done
75
76 echo tar xjpf "${DISTDIR}"/${MY_P}.tar.bz2 ${targets}
77 tar xjpf "${DISTDIR}"/${MY_P}.tar.bz2 ${targets}
78
79 case "${PV}" in
80 4.4.0|4.4.0_rc*)
81 echo tar xjpf "${DISTDIR}"/${MY_P}-headers.tar.bz2
82 tar xjpf "${DISTDIR}"/${MY_P}-headers.tar.bz2
83 ;;
84 esac
85} 531}
86 532
87qt4-build_src_unpack() { 533# @FUNCTION: build_directories
88 qt4_unpack 534# @USAGE: < directories >
89 if [[ ${PN} != qt-core ]]; then 535# @INTERNAL
90 cd "${S}" 536# @DESCRIPTION:
91 skip_qmake_build_patch 537# Compiles the code in the given list of directories.
92 skip_project_generation_patch
93 symlink_binaries_to_buildtree
94 fi
95
96 sed -e "s:QMAKE_CFLAGS_RELEASE.*=.*:QMAKE_CFLAGS_RELEASE=${CFLAGS}:" \
97 -e "s:QMAKE_CXXFLAGS_RELEASE.*=.*:QMAKE_CXXFLAGS_RELEASE=${CXXFLAGS}:" \
98 -e "s:QMAKE_LFLAGS_RELEASE.*=.*:QMAKE_LFLAGS_RELEASE=${LDFLAGS}:" \
99 -e "s:X11R6/::" \
100 -i "${S}"/mkspecs/$(qt_mkspecs_dir)/qmake.conf || die "sed ${S}/mkspecs/$(qt_mkspecs_dir)/qmake.conf failed"
101
102 sed -e "s:QMAKE_CFLAGS_RELEASE.*=.*:QMAKE_CFLAGS_RELEASE=${CFLAGS}:" \
103 -e "s:QMAKE_CXXFLAGS_RELEASE.*=.*:QMAKE_CXXFLAGS_RELEASE=${CXXFLAGS}:" \
104 -e "s:QMAKE_LFLAGS_RELEASE.*=.*:QMAKE_LFLAGS_RELEASE=${LDFLAGS}:" \
105 -i "${S}"/mkspecs/common/g++.conf || die "sed ${S}/mkspecs/common/g++.conf failed"
106}
107
108qt4-build_src_compile() {
109 # Don't let the user go too overboard with flags. If you really want to, uncomment
110 # out the line below and give 'er a whirl.
111 strip-flags
112 replace-flags -O3 -O2
113
114 if [[ $(gcc-fullversion) == "3.4.6" && gcc-specs-ssp ]] ; then
115 ewarn "Appending -fno-stack-protector to CFLAGS/CXXFLAGS"
116 append-flags -fno-stack-protector
117 fi
118
119 # Bug 178652
120 if [[ "$(gcc-major-version)" == "3" ]] && use amd64; then
121 ewarn "Appending -fno-gcse to CFLAGS/CXXFLAGS"
122 append-flags -fno-gcse
123 fi
124
125 myconf="$(standard_configure_options) ${myconf}"
126
127 echo ./configure ${myconf}
128 ./configure ${myconf} || die "./configure failed"
129
130 build_target_directories
131}
132
133qt4-build_src_install() {
134 install_directories "${QT4_TARGET_DIRECTORIES}"
135 install_qconfigs
136 fix_library_files
137}
138
139standard_configure_options() {
140 local myconf=""
141
142 [[ $(get_libdir) != "lib" ]] && myconf="${myconf} -L/usr/$(get_libdir)"
143
144 # Disable visibility explicitly if gcc version isn't 4
145 if [[ "$(gcc-major-version)" -lt "4" ]]; then
146 myconf="${myconf} -no-reduce-exports"
147 fi
148
149 # precompiled headers doesn't work on hardened, where the flag is masked.
150 if use pch; then
151 myconf="${myconf} -pch"
152 else
153 myconf="${myconf} -no-pch"
154 fi
155
156 if use debug; then
157 myconf="${myconf} -debug -no-separate-debug-info"
158 else
159 myconf="${myconf} -release -no-separate-debug-info"
160 fi
161
162 # ARCH is set on Gentoo. QT now falls back to generic on an unsupported
163 # ${ARCH}. Therefore we convert it to supported values.
164 case "${ARCH}" in
165 amd64) myconf="${myconf} -arch x86_64" ;;
166 ppc|ppc64) myconf="${myconf} -arch powerpc" ;;
167 x86) myconf="${myconf} -arch i386" ;;
168 alpha|arm|ia64|mips|s390|sparc) myconf="${myconf} -arch ${ARCH}" ;;
169 hppa|sh) myconf="${myconf} -arch generic" ;;
170 *) die "${ARCH} is unsupported by this eclass. Please file a bug." ;;
171 esac
172
173 myconf="${myconf} -stl -verbose -largefile -confirm-license -no-rpath
174 -prefix ${QTPREFIXDIR} -bindir ${QTBINDIR} -libdir ${QTLIBDIR}
175 -datadir ${QTDATADIR} -docdir ${QTDOCDIR} -headerdir ${QTHEADERDIR}
176 -plugindir ${QTPLUGINDIR} -sysconfdir ${QTSYSCONFDIR}
177 -translationdir ${QTTRANSDIR} -examplesdir ${QTEXAMPLESDIR}
178 -demosdir ${QTDEMOSDIR} -silent -fast -reduce-relocations
179 -nomake examples -nomake demos"
180
181 echo "${myconf}"
182}
183
184build_target_directories() {
185 build_directories "${QT4_TARGET_DIRECTORIES}"
186}
187
188build_directories() { 538build_directories() {
189 local dirs="$@"
190 for x in ${dirs}; do 539 for x in "$@"; do
191 cd "${S}"/${x} 540 pushd "${S}"/${x} >/dev/null || die
192 "${S}"/bin/qmake "LIBS+=-L${QTLIBDIR}" "CONFIG+=nostrip" || die "qmake failed" 541 emake \
193 emake || die "emake failed" 542 AR="$(tc-getAR) cqs" \
543 CC="$(tc-getCC)" \
544 CXX="$(tc-getCXX)" \
545 LINK="$(tc-getCXX)" \
546 RANLIB=":" \
547 STRIP=":"
548 popd >/dev/null || die
194 done 549 done
195} 550}
196 551
552# @FUNCTION: install_directories
553# @USAGE: < directories >
554# @INTERNAL
555# @DESCRIPTION:
556# Runs emake install in the given directories, which are separated by spaces.
197install_directories() { 557install_directories() {
198 local dirs="$@"
199 for x in ${dirs}; do 558 for x in "$@"; do
200 pushd "${S}"/${x} >/dev/null || die "Can't pushd ${S}/${x}" 559 pushd "${S}"/${x} >/dev/null || die
201 emake INSTALL_ROOT="${D}" install || die "emake install failed" 560 emake INSTALL_ROOT="${D}" install
202 popd >/dev/null || die "Can't popd from ${S}/${x}" 561 popd >/dev/null || die
203 done 562 done
204} 563}
205 564
206# @ECLASS-VARIABLE: QCONFIG_ADD 565# @ECLASS-VARIABLE: QCONFIG_ADD
207# @DESCRIPTION: 566# @DESCRIPTION:
208# List options that need to be added to QT_CONFIG in qconfig.pri 567# List options that need to be added to QT_CONFIG in qconfig.pri
209QCONFIG_ADD="${QCONFIG_ADD:-}" 568: ${QCONFIG_ADD:=}
210 569
211# @ECLASS-VARIABLE: QCONFIG_REMOVE 570# @ECLASS-VARIABLE: QCONFIG_REMOVE
212# @DESCRIPTION: 571# @DESCRIPTION:
213# List options that need to be removed from QT_CONFIG in qconfig.pri 572# List options that need to be removed from QT_CONFIG in qconfig.pri
214QCONFIG_REMOVE="${QCONFIG_REMOVE:-}" 573: ${QCONFIG_REMOVE:=}
215 574
216# @ECLASS-VARIABLE: QCONFIG_DEFINE 575# @ECLASS-VARIABLE: QCONFIG_DEFINE
217# @DESCRIPTION: 576# @DESCRIPTION:
218# List variables that should be defined at the top of QtCore/qconfig.h 577# List variables that should be defined at the top of QtCore/qconfig.h
219QCONFIG_DEFINE="${QCONFIG_DEFINE:-}" 578: ${QCONFIG_DEFINE:=}
220 579
580# @FUNCTION: install_qconfigs
581# @INTERNAL
582# @DESCRIPTION:
583# Install gentoo-specific mkspecs configurations.
221install_qconfigs() { 584install_qconfigs() {
222 local x 585 local x
223 if [[ -n ${QCONFIG_ADD} || -n ${QCONFIG_REMOVE} ]]; then 586 if [[ -n ${QCONFIG_ADD} || -n ${QCONFIG_REMOVE} ]]; then
224 for x in QCONFIG_ADD QCONFIG_REMOVE; do 587 for x in QCONFIG_ADD QCONFIG_REMOVE; do
225 [[ -n ${!x} ]] && echo ${x}=${!x} >> "${T}"/${PN}-qconfig.pri 588 [[ -n ${!x} ]] && echo ${x}=${!x} >> "${T}"/${PN}-qconfig.pri
226 done 589 done
227 insinto ${QTDATADIR}/mkspecs/gentoo 590 insinto ${QTDATADIR#${EPREFIX}}/mkspecs/gentoo
228 doins "${T}"/${PN}-qconfig.pri || die "installing ${PN}-qconfig.pri failed" 591 doins "${T}"/${PN}-qconfig.pri
229 fi 592 fi
230 593
231 if [[ -n ${QCONFIG_DEFINE} ]]; then 594 if [[ -n ${QCONFIG_DEFINE} ]]; then
232 for x in ${QCONFIG_DEFINE}; do 595 for x in ${QCONFIG_DEFINE}; do
233 echo "#define ${x}" >> "${T}"/gentoo-${PN}-qconfig.h 596 echo "#define ${x}" >> "${T}"/gentoo-${PN}-qconfig.h
234 done 597 done
235 insinto ${QTHEADERDIR}/Gentoo 598 insinto ${QTHEADERDIR#${EPREFIX}}/Gentoo
236 doins "${T}"/gentoo-${PN}-qconfig.h || die "installing ${PN}-qconfig.h failed" 599 doins "${T}"/gentoo-${PN}-qconfig.h
237 fi 600 fi
238} 601}
239 602
240# Stubs for functions used by the Qt 4.4.0_technical_preview_1. 603# @FUNCTION: generate_qconfigs
241qconfig_add_option() { : ; } 604# @INTERNAL
242qconfig_remove_option() { : ; } 605# @DESCRIPTION:
243 606# Generates gentoo-specific qconfig.{h,pri}.
244generate_qconfigs() { 607generate_qconfigs() {
245 if [[ -n ${QCONFIG_ADD} || -n ${QCONFIG_REMOVE} || -n ${QCONFIG_DEFINE} || ${CATEGORY}/${PN} == x11-libs/qt-core ]]; then 608 if [[ -n ${QCONFIG_ADD} || -n ${QCONFIG_REMOVE} || -n ${QCONFIG_DEFINE} || ${CATEGORY}/${PN} == dev-qt/qtcore ]]; then
246 local x qconfig_add qconfig_remove qconfig_new 609 local x qconfig_add qconfig_remove qconfig_new
247 for x in "${ROOT}${QTDATADIR}"/mkspecs/gentoo/*-qconfig.pri; do 610 for x in "${ROOT}${QTDATADIR}"/mkspecs/gentoo/*-qconfig.pri; do
248 [[ -f ${x} ]] || continue 611 [[ -f ${x} ]] || continue
249 qconfig_add="${qconfig_add} $(sed -n 's/^QCONFIG_ADD=//p' "${x}")" 612 qconfig_add+=" $(sed -n 's/^QCONFIG_ADD=//p' "${x}")"
250 qconfig_remove="${qconfig_remove} $(sed -n 's/^QCONFIG_REMOVE=//p' "${x}")" 613 qconfig_remove+=" $(sed -n 's/^QCONFIG_REMOVE=//p' "${x}")"
251 done 614 done
252 615
253 # these error checks do not use die because dying in pkg_post{inst,rm} 616 # these error checks do not use die because dying in pkg_post{inst,rm}
254 # just makes things worse. 617 # just makes things worse.
255 if [[ -e "${ROOT}${QTDATADIR}"/mkspecs/gentoo/qconfig.pri ]]; then 618 if [[ -e "${ROOT}${QTDATADIR}"/mkspecs/gentoo/qconfig.pri ]]; then
256 # start with the qconfig.pri that qt-core installed 619 # start with the qconfig.pri that qtcore installed
257 if ! cp "${ROOT}${QTDATADIR}"/mkspecs/gentoo/qconfig.pri \ 620 if ! cp "${ROOT}${QTDATADIR}"/mkspecs/gentoo/qconfig.pri \
258 "${ROOT}${QTDATADIR}"/mkspecs/qconfig.pri; then 621 "${ROOT}${QTDATADIR}"/mkspecs/qconfig.pri; then
259 eerror "cp qconfig failed." 622 eerror "cp qconfig failed."
260 return 1 623 return 1
261 fi 624 fi
262 625
263 # generate list of QT_CONFIG entries from the existing list 626 # generate list of QT_CONFIG entries from the existing list
264 # including qconfig_add and excluding qconfig_remove 627 # including qconfig_add and excluding qconfig_remove
265 for x in $(sed -n 's/^QT_CONFIG +=//p' \ 628 for x in $(sed -n 's/^QT_CONFIG +=//p' \
266 "${ROOT}${QTDATADIR}"/mkspecs/qconfig.pri) ${qconfig_add}; do 629 "${ROOT}${QTDATADIR}"/mkspecs/qconfig.pri) ${qconfig_add}; do
267 hasq ${x} ${qconfig_remove} || qconfig_new="${qconfig_new} ${x}" 630 has ${x} ${qconfig_remove} || qconfig_new+=" ${x}"
268 done 631 done
269 632
270 # replace the existing QT_CONFIG list with qconfig_new 633 # replace the existing QT_CONFIG list with qconfig_new
271 if ! sed -i -e "s/QT_CONFIG +=.*/QT_CONFIG += ${qconfig_new}/" \ 634 if ! sed -i -e "s/QT_CONFIG +=.*/QT_CONFIG += ${qconfig_new}/" \
272 "${ROOT}${QTDATADIR}"/mkspecs/qconfig.pri; then 635 "${ROOT}${QTDATADIR}"/mkspecs/qconfig.pri; then
295 "${ROOT}${QTHEADERDIR}" 2>/dev/null 658 "${ROOT}${QTHEADERDIR}" 2>/dev/null
296 fi 659 fi
297 fi 660 fi
298} 661}
299 662
663# @FUNCTION: qt4-build_pkg_postrm
664# @DESCRIPTION:
665# Regenerate configuration when the package is completely removed.
300qt4-build_pkg_postrm() { 666qt4-build_pkg_postrm() {
301 generate_qconfigs 667 generate_qconfigs
302} 668}
303 669
670# @FUNCTION: qt4-build_pkg_postinst
671# @DESCRIPTION:
672# Regenerate configuration, plus throw a message about possible
673# breakages and proposed solutions.
304qt4-build_pkg_postinst() { 674qt4-build_pkg_postinst() {
305 generate_qconfigs 675 generate_qconfigs
306} 676}
307 677
678# @FUNCTION: skip_qmake_build
679# @INTERNAL
680# @DESCRIPTION:
681# Patches configure to skip qmake compilation, as it's already installed by qtcore.
308skip_qmake_build_patch() { 682skip_qmake_build() {
309 # Don't need to build qmake, as it's already installed from qt-core
310 sed -i -e "s:if true:if false:g" "${S}"/configure || die "Sed failed" 683 sed -i -e "s:if true:if false:g" "${S}"/configure || die
311} 684}
312 685
313skip_project_generation_patch() { 686# @FUNCTION: skip_project_generation
687# @INTERNAL
688# @DESCRIPTION:
314 # Exit the script early by throwing in an exit before all of the .pro files are scanned 689# Exit the script early by throwing in an exit before all of the .pro files are scanned.
690skip_project_generation() {
315 sed -e "s:echo \"Finding:exit 0\n\necho \"Finding:g" \ 691 sed -i -e "s:echo \"Finding:exit 0\n\necho \"Finding:g" "${S}"/configure || die
316 -i "${S}"/configure || die "Sed failed"
317} 692}
318 693
694# @FUNCTION: symlink_binaries_to_buildtree
695# @INTERNAL
696# @DESCRIPTION:
697# Symlinks generated binaries to buildtree, so they can be used during compilation time.
319symlink_binaries_to_buildtree() { 698symlink_binaries_to_buildtree() {
320 for bin in qmake moc uic rcc; do 699 for bin in qmake moc uic rcc; do
321 ln -s ${QTBINDIR}/${bin} "${S}"/bin/ || die "Symlinking ${bin} to ${S}/bin failed." 700 ln -s "${QTBINDIR}"/${bin} "${S}"/bin/ || die "symlinking ${bin} to ${S}/bin failed"
322 done 701 done
323} 702}
324 703
704# @FUNCTION: fix_library_files
705# @INTERNAL
706# @DESCRIPTION:
707# Fixes the paths in *.la, *.prl, *.pc, as they are wrong due to sandbox and
708# moves the *.pc files into the pkgconfig directory.
325fix_library_files() { 709fix_library_files() {
710 local libfile
326 for libfile in "${D}"/${QTLIBDIR}/{*.la,*.prl,pkgconfig/*.pc}; do 711 for libfile in "${D}"/${QTLIBDIR}/{*.la,*.prl,pkgconfig/*.pc}; do
327 if [[ -e ${libfile} ]]; then 712 if [[ -e ${libfile} ]]; then
328 sed -i -e "s:${S}/lib:${QTLIBDIR}:g" ${libfile} || die "Sed on ${libfile} failed." 713 sed -i -e "s:${S}/lib:${QTLIBDIR}:g" ${libfile} || die "sed on ${libfile} failed"
329 fi 714 fi
330 done 715 done
331 716
332 # pkgconfig files refer to WORKDIR/bin as the moc and uic locations. Fix: 717 # pkgconfig files refer to WORKDIR/bin as the moc and uic locations
333 for libfile in "${D}"/${QTLIBDIR}/pkgconfig/*.pc; do 718 for libfile in "${D}"/${QTLIBDIR}/pkgconfig/*.pc; do
334 if [[ -e ${libfile} ]]; then 719 if [[ -e ${libfile} ]]; then
335 sed -i -e "s:${S}/bin:${QTBINDIR}:g" ${libfile} || die "Sed failed" 720 sed -i -e "s:${S}/bin:${QTBINDIR}:g" ${libfile} || die "sed on ${libfile} failed"
336 721
337 # Move .pc files into the pkgconfig directory 722 # Move .pc files into the pkgconfig directory
338
339 dodir ${QTPCDIR} 723 dodir ${QTPCDIR#${EPREFIX}}
340 mv ${libfile} "${D}"/${QTPCDIR}/ \ 724 mv ${libfile} "${D}"/${QTPCDIR}/ || die "moving ${libfile} to ${D}/${QTPCDIR}/ failed"
341 || die "Moving ${libfile} to ${D}/${QTPCDIR}/ failed."
342 fi 725 fi
343 done 726 done
344 727
345 # Don't install an empty directory 728 # Don't install an empty directory
346 rmdir "${D}"/${QTLIBDIR}/pkgconfig 729 rmdir "${D}"/${QTLIBDIR}/pkgconfig
347} 730}
348 731
732# @FUNCTION: qt_use
733# @USAGE: < flag > [ feature ] [ enableval ]
734# @DESCRIPTION:
735# This will echo "-${enableval}-${feature}" if <flag> is enabled, or
736# "-no-${feature}" if it's disabled. If [feature] is not specified, <flag>
737# will be used for that. If [enableval] is not specified, it omits the
738# "-${enableval}" part.
349qt_use() { 739qt_use() {
350 local flag="${1}" 740 use "$1" && echo "${3:+-$3}-${2:-$1}" || echo "-no-${2:-$1}"
351 local feature="${1}"
352 local enableval=
353
354 [[ -n ${2} ]] && feature=${2}
355 [[ -n ${3} ]] && enableval="-${3}"
356
357 if use ${flag}; then
358 echo "${enableval}-${feature}"
359 else
360 echo "-no-${feature}"
361 fi
362} 741}
363 742
364# @ECLASS-VARIABLE: QT4_BUILT_WITH_USE_CHECK 743# @FUNCTION: qt_mkspecs_dir
744# @RETURN: the specs-directory w/o path
365# @DESCRIPTION: 745# @DESCRIPTION:
366# The contents of $QT4_BUILT_WITH_USE_CHECK gets fed to built_with_use 746# Allows us to define which mkspecs dir we want to use.
367# (eutils.eclass), line per line.
368#
369# Example:
370# @CODE
371# pkg_setup() {
372# use qt3support && QT4_BUILT_WITH_USE_CHECK="${QT4_BUILT_WITH_USE_CHECK}
373# ~x11-libs/qt-gui-${PV} qt3support"
374# qt4-build_check_use
375# }
376# @CODE
377
378# Run built_with_use on each flag and print appropriate error messages if any
379# flags are missing
380_qt_built_with_use() {
381 local missing opt pkg flag flags
382
383 if [[ ${1} = "--missing" ]]; then
384 missing="${1} ${2}" && shift 2
385 fi
386 if [[ ${1:0:1} = "-" ]]; then
387 opt=${1} && shift
388 fi
389
390 pkg=${1} && shift
391
392 for flag in "${@}"; do
393 flags="${flags} ${flag}"
394 if ! built_with_use ${missing} ${opt} ${pkg} ${flag}; then
395 flags="${flags}*"
396 else
397 [[ ${opt} = "-o" ]] && return 0
398 fi
399 done
400 if [[ "${flags# }" = "${@}" ]]; then
401 return 0
402 fi
403 if [[ ${opt} = "-o" ]]; then
404 eerror "This package requires '${pkg}' to be built with any of the following USE flags: '$*'."
405 else
406 eerror "This package requires '${pkg}' to be built with the following USE flags: '${flags# }'."
407 fi
408 return 1
409}
410
411# @FUNCTION: qt4-build_check_use
412# @DESCRIPTION:
413# Check if the listed packages in $QT4_BUILT_WITH_USE_CHECK are built with the
414# USE flags listed.
415#
416# If any of the required USE flags are missing, an eerror will be printed for
417# each package with missing USE flags.
418qt4-build_check_use() {
419 local line missing
420 while read line; do
421 [[ -z ${line} ]] && continue
422 if ! _qt_built_with_use ${line}; then
423 missing=true
424 fi
425 done <<< "${QT4_BUILT_WITH_USE_CHECK}"
426 if [[ -n ${missing} ]]; then
427 echo
428 eerror "Flags marked with an * are missing."
429 die "Missing USE flags found"
430 fi
431}
432
433qt_mkspecs_dir() { 747qt_mkspecs_dir() {
434 # Allows us to define which mkspecs dir we want to use.
435 local spec 748 local spec=
436 749
437 case ${CHOST} in 750 case "${CHOST}" in
438 *-freebsd*|*-dragonfly*) 751 *-freebsd*|*-dragonfly*)
439 spec="freebsd" ;; 752 spec=freebsd ;;
440 *-openbsd*) 753 *-openbsd*)
441 spec="openbsd" ;; 754 spec=openbsd ;;
442 *-netbsd*) 755 *-netbsd*)
443 spec="netbsd" ;; 756 spec=netbsd ;;
444 *-darwin*) 757 *-darwin*)
758 if use aqua; then
759 # mac with carbon/cocoa
760 spec=macx
761 else
762 # darwin/mac with x11
445 spec="darwin" ;; 763 spec=darwin
764 fi
765 ;;
766 *-solaris*)
767 spec=solaris ;;
446 *-linux-*|*-linux) 768 *-linux-*|*-linux)
447 spec="linux" ;; 769 spec=linux ;;
448 *) 770 *)
449 die "Unknown CHOST, no platform choosen." 771 die "${FUNCNAME}(): Unknown CHOST '${CHOST}'" ;;
450 esac 772 esac
451 773
452 CXX=$(tc-getCXX) 774 case "$(tc-getCXX)" in
453 if [[ ${CXX/g++/} != ${CXX} ]]; then 775 *g++*)
454 spec="${spec}-g++" 776 spec+=-g++ ;;
455 elif [[ ${CXX/icpc/} != ${CXX} ]]; then 777 *icpc*)
456 spec="${spec}-icc" 778 spec+=-icc ;;
457 else 779 *)
458 die "Unknown compiler ${CXX}." 780 die "${FUNCNAME}(): Unknown compiler '$(tc-getCXX)'" ;;
781 esac
782
783 # Add -64 for 64bit profiles
784 if use x64-freebsd ||
785 use amd64-linux ||
786 use x64-macos ||
787 use x64-solaris ||
788 use sparc64-solaris
789 then
790 spec+=-64
459 fi 791 fi
460 792
461 echo "${spec}" 793 echo "${spec}"
462} 794}
463 795
796# @FUNCTION: qt_nolibx11
797# @INTERNAL
798# @DESCRIPTION:
799# Skip X11 tests for packages that don't need X libraries installed.
800qt_nolibx11() {
801 sed -i -e '/^if.*PLATFORM_X11.*CFG_GUI/,/^fi$/d' "${S}"/configure || die
802}
803
464EXPORT_FUNCTIONS pkg_setup src_unpack src_compile src_install pkg_postrm pkg_postinst 804EXPORT_FUNCTIONS pkg_setup src_unpack src_prepare src_configure src_compile src_install src_test pkg_postrm pkg_postinst

Legend:
Removed from v.1.13  
changed lines
  Added in v.1.150

  ViewVC Help
Powered by ViewVC 1.1.20